<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.jbase.marshal;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.DataInput;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.DataOutput;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.IOException;<a name="line.38"></a>
<FONT color="green">039</FONT>    <a name="line.39"></a>
<FONT color="green">040</FONT>    import ch.javasoft.jbase.EntityMarshaller;<a name="line.40"></a>
<FONT color="green">041</FONT>    import ch.javasoft.jbase.FixedWidthMarshaller;<a name="line.41"></a>
<FONT color="green">042</FONT>    import ch.javasoft.jbase.FixedWidthTable;<a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.jbase.VariableWidthTable;<a name="line.43"></a>
<FONT color="green">044</FONT>    <a name="line.44"></a>
<FONT color="green">045</FONT>    /**<a name="line.45"></a>
<FONT color="green">046</FONT>     * &lt;tt&gt;PrimitiveArrayMarshallers&lt;/tt&gt; contains constants and static methods to<a name="line.46"></a>
<FONT color="green">047</FONT>     * access marshallers for one dimensional arrays of primitive data types. One <a name="line.47"></a>
<FONT color="green">048</FONT>     * row (or entity) corresponds to an array of some primitive Java data type.<a name="line.48"></a>
<FONT color="green">049</FONT>     * &lt;p&gt;<a name="line.49"></a>
<FONT color="green">050</FONT>     * If the array size is previously known, the appropriate static method can<a name="line.50"></a>
<FONT color="green">051</FONT>     * be used to create a {@link FixedWidthMarshaller} instance for the specified <a name="line.51"></a>
<FONT color="green">052</FONT>     * array size. Such marshallers can be used with a {@link FixedWidthTable}.<a name="line.52"></a>
<FONT color="green">053</FONT>     * &lt;p&gt;<a name="line.53"></a>
<FONT color="green">054</FONT>     * If the array size is not known and possibly varying for different entity <a name="line.54"></a>
<FONT color="green">055</FONT>     * instances (or rows), the constant marshallers can be used. They write the <a name="line.55"></a>
<FONT color="green">056</FONT>     * array length for each row and are not {@link FixedWidthMarshaller} instances.<a name="line.56"></a>
<FONT color="green">057</FONT>     * Such marshallers can be used with a {@link VariableWidthTable}.<a name="line.57"></a>
<FONT color="green">058</FONT>     */<a name="line.58"></a>
<FONT color="green">059</FONT>    public class PrimitiveArrayMarshallers {<a name="line.59"></a>
<FONT color="green">060</FONT>    <a name="line.60"></a>
<FONT color="green">061</FONT>            public static final EntityMarshaller&lt;byte[]&gt; BYTE = new EntityMarshaller&lt;byte[]&gt;() {<a name="line.61"></a>
<FONT color="green">062</FONT>                    public void writeTo(byte[] entity, DataOutput out) throws IOException {<a name="line.62"></a>
<FONT color="green">063</FONT>                            out.writeInt(entity.length);<a name="line.63"></a>
<FONT color="green">064</FONT>                            out.write(entity);<a name="line.64"></a>
<FONT color="green">065</FONT>                    }<a name="line.65"></a>
<FONT color="green">066</FONT>                    public byte[] readFrom(DataInput in) throws IOException {<a name="line.66"></a>
<FONT color="green">067</FONT>                            final int len = in.readInt();<a name="line.67"></a>
<FONT color="green">068</FONT>                            final byte[] arr = new byte[len];<a name="line.68"></a>
<FONT color="green">069</FONT>                            in.readFully(arr);<a name="line.69"></a>
<FONT color="green">070</FONT>                            return arr;<a name="line.70"></a>
<FONT color="green">071</FONT>                    }<a name="line.71"></a>
<FONT color="green">072</FONT>            };<a name="line.72"></a>
<FONT color="green">073</FONT>            public static final EntityMarshaller&lt;short[]&gt; SHORT = new EntityMarshaller&lt;short[]&gt;() {<a name="line.73"></a>
<FONT color="green">074</FONT>                    public void writeTo(short[] entity, DataOutput out) throws IOException {<a name="line.74"></a>
<FONT color="green">075</FONT>                            out.writeInt(entity.length);<a name="line.75"></a>
<FONT color="green">076</FONT>                            for (int i = 0; i &lt; entity.length; i++) {<a name="line.76"></a>
<FONT color="green">077</FONT>                                    out.writeShort(entity[i]);<a name="line.77"></a>
<FONT color="green">078</FONT>                            }<a name="line.78"></a>
<FONT color="green">079</FONT>                    }<a name="line.79"></a>
<FONT color="green">080</FONT>                    public short[] readFrom(DataInput in) throws IOException {<a name="line.80"></a>
<FONT color="green">081</FONT>                            final int len = in.readInt();<a name="line.81"></a>
<FONT color="green">082</FONT>                            final short[] arr = new short[len];<a name="line.82"></a>
<FONT color="green">083</FONT>                            for (int i = 0; i &lt; len; i++) {<a name="line.83"></a>
<FONT color="green">084</FONT>                                    arr[i] = in.readShort();<a name="line.84"></a>
<FONT color="green">085</FONT>                            }                       <a name="line.85"></a>
<FONT color="green">086</FONT>                            return arr;<a name="line.86"></a>
<FONT color="green">087</FONT>                    }<a name="line.87"></a>
<FONT color="green">088</FONT>            };<a name="line.88"></a>
<FONT color="green">089</FONT>            public static final EntityMarshaller&lt;int[]&gt; INT = new EntityMarshaller&lt;int[]&gt;() {<a name="line.89"></a>
<FONT color="green">090</FONT>                    public void writeTo(int[] entity, DataOutput out) throws IOException {<a name="line.90"></a>
<FONT color="green">091</FONT>                            out.writeInt(entity.length);<a name="line.91"></a>
<FONT color="green">092</FONT>                            for (int i = 0; i &lt; entity.length; i++) {<a name="line.92"></a>
<FONT color="green">093</FONT>                                    out.writeInt(entity[i]);<a name="line.93"></a>
<FONT color="green">094</FONT>                            }<a name="line.94"></a>
<FONT color="green">095</FONT>                    }<a name="line.95"></a>
<FONT color="green">096</FONT>                    public int[] readFrom(DataInput in) throws IOException {<a name="line.96"></a>
<FONT color="green">097</FONT>                            final int len = in.readInt();<a name="line.97"></a>
<FONT color="green">098</FONT>                            final int[] arr = new int[len];<a name="line.98"></a>
<FONT color="green">099</FONT>                            for (int i = 0; i &lt; len; i++) {<a name="line.99"></a>
<FONT color="green">100</FONT>                                    arr[i] = in.readInt();<a name="line.100"></a>
<FONT color="green">101</FONT>                            }                       <a name="line.101"></a>
<FONT color="green">102</FONT>                            return arr;<a name="line.102"></a>
<FONT color="green">103</FONT>                    }<a name="line.103"></a>
<FONT color="green">104</FONT>            };<a name="line.104"></a>
<FONT color="green">105</FONT>            public static final EntityMarshaller&lt;long[]&gt; LONG = new EntityMarshaller&lt;long[]&gt;() {<a name="line.105"></a>
<FONT color="green">106</FONT>                    public void writeTo(long[] entity, DataOutput out) throws IOException {<a name="line.106"></a>
<FONT color="green">107</FONT>                            out.writeInt(entity.length);<a name="line.107"></a>
<FONT color="green">108</FONT>                            for (int i = 0; i &lt; entity.length; i++) {<a name="line.108"></a>
<FONT color="green">109</FONT>                                    out.writeLong(entity[i]);<a name="line.109"></a>
<FONT color="green">110</FONT>                            }<a name="line.110"></a>
<FONT color="green">111</FONT>                    }<a name="line.111"></a>
<FONT color="green">112</FONT>                    public long[] readFrom(DataInput in) throws IOException {<a name="line.112"></a>
<FONT color="green">113</FONT>                            final int len = in.readInt();<a name="line.113"></a>
<FONT color="green">114</FONT>                            final long[] arr = new long[len];<a name="line.114"></a>
<FONT color="green">115</FONT>                            for (int i = 0; i &lt; len; i++) {<a name="line.115"></a>
<FONT color="green">116</FONT>                                    arr[i] = in.readLong();<a name="line.116"></a>
<FONT color="green">117</FONT>                            }                       <a name="line.117"></a>
<FONT color="green">118</FONT>                            return arr;<a name="line.118"></a>
<FONT color="green">119</FONT>                    }<a name="line.119"></a>
<FONT color="green">120</FONT>            };<a name="line.120"></a>
<FONT color="green">121</FONT>            public static final EntityMarshaller&lt;float[]&gt; FLOAT = new EntityMarshaller&lt;float[]&gt;() {<a name="line.121"></a>
<FONT color="green">122</FONT>                    public void writeTo(float[] entity, DataOutput out) throws IOException {<a name="line.122"></a>
<FONT color="green">123</FONT>                            out.writeInt(entity.length);<a name="line.123"></a>
<FONT color="green">124</FONT>                            for (int i = 0; i &lt; entity.length; i++) {<a name="line.124"></a>
<FONT color="green">125</FONT>                                    out.writeFloat(entity[i]);<a name="line.125"></a>
<FONT color="green">126</FONT>                            }<a name="line.126"></a>
<FONT color="green">127</FONT>                    }<a name="line.127"></a>
<FONT color="green">128</FONT>                    public float[] readFrom(DataInput in) throws IOException {<a name="line.128"></a>
<FONT color="green">129</FONT>                            final int len = in.readInt();<a name="line.129"></a>
<FONT color="green">130</FONT>                            final float[] arr = new float[len];<a name="line.130"></a>
<FONT color="green">131</FONT>                            for (int i = 0; i &lt; len; i++) {<a name="line.131"></a>
<FONT color="green">132</FONT>                                    arr[i] = in.readFloat();<a name="line.132"></a>
<FONT color="green">133</FONT>                            }                       <a name="line.133"></a>
<FONT color="green">134</FONT>                            return arr;<a name="line.134"></a>
<FONT color="green">135</FONT>                    }<a name="line.135"></a>
<FONT color="green">136</FONT>            };<a name="line.136"></a>
<FONT color="green">137</FONT>            public static final EntityMarshaller&lt;double[]&gt; DOUBLE = new EntityMarshaller&lt;double[]&gt;() {<a name="line.137"></a>
<FONT color="green">138</FONT>                    public void writeTo(double[] entity, DataOutput out) throws IOException {<a name="line.138"></a>
<FONT color="green">139</FONT>                            out.writeInt(entity.length);<a name="line.139"></a>
<FONT color="green">140</FONT>                            for (int i = 0; i &lt; entity.length; i++) {<a name="line.140"></a>
<FONT color="green">141</FONT>                                    out.writeDouble(entity[i]);<a name="line.141"></a>
<FONT color="green">142</FONT>                            }<a name="line.142"></a>
<FONT color="green">143</FONT>                    }<a name="line.143"></a>
<FONT color="green">144</FONT>                    public double[] readFrom(DataInput in) throws IOException {<a name="line.144"></a>
<FONT color="green">145</FONT>                            final int len = in.readInt();<a name="line.145"></a>
<FONT color="green">146</FONT>                            final double[] arr = new double[len];<a name="line.146"></a>
<FONT color="green">147</FONT>                            for (int i = 0; i &lt; len; i++) {<a name="line.147"></a>
<FONT color="green">148</FONT>                                    arr[i] = in.readDouble();<a name="line.148"></a>
<FONT color="green">149</FONT>                            }                       <a name="line.149"></a>
<FONT color="green">150</FONT>                            return arr;<a name="line.150"></a>
<FONT color="green">151</FONT>                    }<a name="line.151"></a>
<FONT color="green">152</FONT>            };<a name="line.152"></a>
<FONT color="green">153</FONT>            public static final EntityMarshaller&lt;boolean[]&gt; BOOLEAN = new EntityMarshaller&lt;boolean[]&gt;() {<a name="line.153"></a>
<FONT color="green">154</FONT>                    public void writeTo(boolean[] entity, DataOutput out) throws IOException {<a name="line.154"></a>
<FONT color="green">155</FONT>                            out.writeInt(entity.length);<a name="line.155"></a>
<FONT color="green">156</FONT>                            for (int i = 0; i &lt; entity.length; i++) {<a name="line.156"></a>
<FONT color="green">157</FONT>                                    out.writeBoolean(entity[i]);<a name="line.157"></a>
<FONT color="green">158</FONT>                            }<a name="line.158"></a>
<FONT color="green">159</FONT>                    }<a name="line.159"></a>
<FONT color="green">160</FONT>                    public boolean[] readFrom(DataInput in) throws IOException {<a name="line.160"></a>
<FONT color="green">161</FONT>                            final int len = in.readInt();<a name="line.161"></a>
<FONT color="green">162</FONT>                            final boolean[] arr = new boolean[len];<a name="line.162"></a>
<FONT color="green">163</FONT>                            for (int i = 0; i &lt; len; i++) {<a name="line.163"></a>
<FONT color="green">164</FONT>                                    arr[i] = in.readBoolean();<a name="line.164"></a>
<FONT color="green">165</FONT>                            }                       <a name="line.165"></a>
<FONT color="green">166</FONT>                            return arr;<a name="line.166"></a>
<FONT color="green">167</FONT>                    }<a name="line.167"></a>
<FONT color="green">168</FONT>            };<a name="line.168"></a>
<FONT color="green">169</FONT>            public static final EntityMarshaller&lt;char[]&gt; CHAR = new EntityMarshaller&lt;char[]&gt;() {<a name="line.169"></a>
<FONT color="green">170</FONT>                    public void writeTo(char[] entity, DataOutput out) throws IOException {<a name="line.170"></a>
<FONT color="green">171</FONT>                            out.writeInt(entity.length);<a name="line.171"></a>
<FONT color="green">172</FONT>                            for (int i = 0; i &lt; entity.length; i++) {<a name="line.172"></a>
<FONT color="green">173</FONT>                                    out.writeChar(entity[i]);<a name="line.173"></a>
<FONT color="green">174</FONT>                            }<a name="line.174"></a>
<FONT color="green">175</FONT>                    }<a name="line.175"></a>
<FONT color="green">176</FONT>                    public char[] readFrom(DataInput in) throws IOException {<a name="line.176"></a>
<FONT color="green">177</FONT>                            final int len = in.readInt();<a name="line.177"></a>
<FONT color="green">178</FONT>                            final char[] arr = new char[len];<a name="line.178"></a>
<FONT color="green">179</FONT>                            for (int i = 0; i &lt; len; i++) {<a name="line.179"></a>
<FONT color="green">180</FONT>                                    arr[i] = in.readChar();<a name="line.180"></a>
<FONT color="green">181</FONT>                            }                       <a name="line.181"></a>
<FONT color="green">182</FONT>                            return arr;<a name="line.182"></a>
<FONT color="green">183</FONT>                    }<a name="line.183"></a>
<FONT color="green">184</FONT>            };<a name="line.184"></a>
<FONT color="green">185</FONT>            <a name="line.185"></a>
<FONT color="green">186</FONT>            public static FixedWidthMarshaller&lt;byte[]&gt; getForFixedByteArray(final int arrayLength) {          <a name="line.186"></a>
<FONT color="green">187</FONT>                    return new FixedWidthMarshaller&lt;byte[]&gt;() {<a name="line.187"></a>
<FONT color="green">188</FONT>                            public void writeTo(byte[] entity, DataOutput out) throws IOException {<a name="line.188"></a>
<FONT color="green">189</FONT>                                    if (entity.length != arrayLength) {<a name="line.189"></a>
<FONT color="green">190</FONT>                                            throw new IOException("invalid array length " + <a name="line.190"></a>
<FONT color="green">191</FONT>                                                            entity.length + ", expected " + arrayLength); <a name="line.191"></a>
<FONT color="green">192</FONT>                                    }<a name="line.192"></a>
<FONT color="green">193</FONT>                                    out.write(entity);<a name="line.193"></a>
<FONT color="green">194</FONT>                            }<a name="line.194"></a>
<FONT color="green">195</FONT>                            public byte[] readFrom(DataInput in) throws IOException {<a name="line.195"></a>
<FONT color="green">196</FONT>                                    final byte[] arr = new byte[arrayLength];<a name="line.196"></a>
<FONT color="green">197</FONT>                                    in.readFully(arr);<a name="line.197"></a>
<FONT color="green">198</FONT>                                    return arr;<a name="line.198"></a>
<FONT color="green">199</FONT>                            }<a name="line.199"></a>
<FONT color="green">200</FONT>                            public int getByteWidth() {return arrayLength;}<a name="line.200"></a>
<FONT color="green">201</FONT>                    };<a name="line.201"></a>
<FONT color="green">202</FONT>            }<a name="line.202"></a>
<FONT color="green">203</FONT>            public static FixedWidthMarshaller&lt;short[]&gt; getForFixedShortArray(final int arrayLength) {<a name="line.203"></a>
<FONT color="green">204</FONT>                    return new FixedWidthMarshaller&lt;short[]&gt;() {<a name="line.204"></a>
<FONT color="green">205</FONT>                            public void writeTo(short[] entity, DataOutput out) throws IOException {<a name="line.205"></a>
<FONT color="green">206</FONT>                                    if (entity.length != arrayLength) {<a name="line.206"></a>
<FONT color="green">207</FONT>                                            throw new IOException("invalid array length " + <a name="line.207"></a>
<FONT color="green">208</FONT>                                                            entity.length + ", expected " + arrayLength); <a name="line.208"></a>
<FONT color="green">209</FONT>                                    }<a name="line.209"></a>
<FONT color="green">210</FONT>                                    for (int i = 0; i &lt; arrayLength; i++) {<a name="line.210"></a>
<FONT color="green">211</FONT>                                            out.writeShort(entity[i]);<a name="line.211"></a>
<FONT color="green">212</FONT>                                    }<a name="line.212"></a>
<FONT color="green">213</FONT>                            }<a name="line.213"></a>
<FONT color="green">214</FONT>                            public short[] readFrom(DataInput in) throws IOException {<a name="line.214"></a>
<FONT color="green">215</FONT>                                    final short[] arr = new short[arrayLength];<a name="line.215"></a>
<FONT color="green">216</FONT>                                    for (int i = 0; i &lt; arr.length; i++) {<a name="line.216"></a>
<FONT color="green">217</FONT>                                            arr[i] = in.readShort();<a name="line.217"></a>
<FONT color="green">218</FONT>                                    }<a name="line.218"></a>
<FONT color="green">219</FONT>                                    return arr;<a name="line.219"></a>
<FONT color="green">220</FONT>                            }<a name="line.220"></a>
<FONT color="green">221</FONT>                            public int getByteWidth() {return 2*arrayLength;}<a name="line.221"></a>
<FONT color="green">222</FONT>                    };<a name="line.222"></a>
<FONT color="green">223</FONT>            }<a name="line.223"></a>
<FONT color="green">224</FONT>            public static FixedWidthMarshaller&lt;int[]&gt; getForFixedIntArray(final int arrayLength) {<a name="line.224"></a>
<FONT color="green">225</FONT>                    return new FixedWidthMarshaller&lt;int[]&gt;() {<a name="line.225"></a>
<FONT color="green">226</FONT>                            public void writeTo(int[] entity, DataOutput out) throws IOException {<a name="line.226"></a>
<FONT color="green">227</FONT>                                    if (entity.length != arrayLength) {<a name="line.227"></a>
<FONT color="green">228</FONT>                                            throw new IOException("invalid array length " + <a name="line.228"></a>
<FONT color="green">229</FONT>                                                            entity.length + ", expected " + arrayLength); <a name="line.229"></a>
<FONT color="green">230</FONT>                                    }<a name="line.230"></a>
<FONT color="green">231</FONT>                                    for (int i = 0; i &lt; arrayLength; i++) {<a name="line.231"></a>
<FONT color="green">232</FONT>                                            out.writeInt(entity[i]);<a name="line.232"></a>
<FONT color="green">233</FONT>                                    }<a name="line.233"></a>
<FONT color="green">234</FONT>                            }<a name="line.234"></a>
<FONT color="green">235</FONT>                            public int[] readFrom(DataInput in) throws IOException {<a name="line.235"></a>
<FONT color="green">236</FONT>                                    final int[] arr = new int[arrayLength];<a name="line.236"></a>
<FONT color="green">237</FONT>                                    for (int i = 0; i &lt; arr.length; i++) {<a name="line.237"></a>
<FONT color="green">238</FONT>                                            arr[i] = in.readInt();<a name="line.238"></a>
<FONT color="green">239</FONT>                                    }<a name="line.239"></a>
<FONT color="green">240</FONT>                                    return arr;<a name="line.240"></a>
<FONT color="green">241</FONT>                            }<a name="line.241"></a>
<FONT color="green">242</FONT>                            public int getByteWidth() {return 4*arrayLength;}<a name="line.242"></a>
<FONT color="green">243</FONT>                    };<a name="line.243"></a>
<FONT color="green">244</FONT>            }<a name="line.244"></a>
<FONT color="green">245</FONT>            public static FixedWidthMarshaller&lt;long[]&gt; getForFixedLongArray(final int arrayLength) {<a name="line.245"></a>
<FONT color="green">246</FONT>                    return new FixedWidthMarshaller&lt;long[]&gt;() {<a name="line.246"></a>
<FONT color="green">247</FONT>                            public void writeTo(long[] entity, DataOutput out) throws IOException {<a name="line.247"></a>
<FONT color="green">248</FONT>                                    if (entity.length != arrayLength) {<a name="line.248"></a>
<FONT color="green">249</FONT>                                            throw new IOException("invalid array length " + <a name="line.249"></a>
<FONT color="green">250</FONT>                                                            entity.length + ", expected " + arrayLength); <a name="line.250"></a>
<FONT color="green">251</FONT>                                    }<a name="line.251"></a>
<FONT color="green">252</FONT>                                    for (int i = 0; i &lt; arrayLength; i++) {<a name="line.252"></a>
<FONT color="green">253</FONT>                                            out.writeLong(entity[i]);<a name="line.253"></a>
<FONT color="green">254</FONT>                                    }<a name="line.254"></a>
<FONT color="green">255</FONT>                            }<a name="line.255"></a>
<FONT color="green">256</FONT>                            public long[] readFrom(DataInput in) throws IOException {<a name="line.256"></a>
<FONT color="green">257</FONT>                                    final long[] arr = new long[arrayLength];<a name="line.257"></a>
<FONT color="green">258</FONT>                                    for (int i = 0; i &lt; arr.length; i++) {<a name="line.258"></a>
<FONT color="green">259</FONT>                                            arr[i] = in.readLong();<a name="line.259"></a>
<FONT color="green">260</FONT>                                    }<a name="line.260"></a>
<FONT color="green">261</FONT>                                    return arr;<a name="line.261"></a>
<FONT color="green">262</FONT>                            }<a name="line.262"></a>
<FONT color="green">263</FONT>                            public int getByteWidth() {return 8*arrayLength;}<a name="line.263"></a>
<FONT color="green">264</FONT>                    };<a name="line.264"></a>
<FONT color="green">265</FONT>            }<a name="line.265"></a>
<FONT color="green">266</FONT>            public static FixedWidthMarshaller&lt;float[]&gt; getForFixedFloatArray(final int arrayLength) {<a name="line.266"></a>
<FONT color="green">267</FONT>                    return new FixedWidthMarshaller&lt;float[]&gt;() {<a name="line.267"></a>
<FONT color="green">268</FONT>                            public void writeTo(float[] entity, DataOutput out) throws IOException {<a name="line.268"></a>
<FONT color="green">269</FONT>                                    if (entity.length != arrayLength) {<a name="line.269"></a>
<FONT color="green">270</FONT>                                            throw new IOException("invalid array length " + <a name="line.270"></a>
<FONT color="green">271</FONT>                                                            entity.length + ", expected " + arrayLength); <a name="line.271"></a>
<FONT color="green">272</FONT>                                    }<a name="line.272"></a>
<FONT color="green">273</FONT>                                    for (int i = 0; i &lt; arrayLength; i++) {<a name="line.273"></a>
<FONT color="green">274</FONT>                                            out.writeFloat(entity[i]);<a name="line.274"></a>
<FONT color="green">275</FONT>                                    }<a name="line.275"></a>
<FONT color="green">276</FONT>                            }<a name="line.276"></a>
<FONT color="green">277</FONT>                            public float[] readFrom(DataInput in) throws IOException {<a name="line.277"></a>
<FONT color="green">278</FONT>                                    final float[] arr = new float[arrayLength];<a name="line.278"></a>
<FONT color="green">279</FONT>                                    for (int i = 0; i &lt; arr.length; i++) {<a name="line.279"></a>
<FONT color="green">280</FONT>                                            arr[i] = in.readFloat();<a name="line.280"></a>
<FONT color="green">281</FONT>                                    }<a name="line.281"></a>
<FONT color="green">282</FONT>                                    return arr;<a name="line.282"></a>
<FONT color="green">283</FONT>                            }<a name="line.283"></a>
<FONT color="green">284</FONT>                            public int getByteWidth() {return 4*arrayLength;}<a name="line.284"></a>
<FONT color="green">285</FONT>                    };<a name="line.285"></a>
<FONT color="green">286</FONT>            }<a name="line.286"></a>
<FONT color="green">287</FONT>            public static FixedWidthMarshaller&lt;double[]&gt; getForFixedDoubleArray(final int arrayLength) {<a name="line.287"></a>
<FONT color="green">288</FONT>                    return new FixedWidthMarshaller&lt;double[]&gt;() {<a name="line.288"></a>
<FONT color="green">289</FONT>                            public void writeTo(double[] entity, DataOutput out) throws IOException {<a name="line.289"></a>
<FONT color="green">290</FONT>                                    if (entity.length != arrayLength) {<a name="line.290"></a>
<FONT color="green">291</FONT>                                            throw new IOException("invalid array length " + <a name="line.291"></a>
<FONT color="green">292</FONT>                                                            entity.length + ", expected " + arrayLength); <a name="line.292"></a>
<FONT color="green">293</FONT>                                    }<a name="line.293"></a>
<FONT color="green">294</FONT>                                    for (int i = 0; i &lt; arrayLength; i++) {<a name="line.294"></a>
<FONT color="green">295</FONT>                                            out.writeDouble(entity[i]);<a name="line.295"></a>
<FONT color="green">296</FONT>                                    }<a name="line.296"></a>
<FONT color="green">297</FONT>                            }<a name="line.297"></a>
<FONT color="green">298</FONT>                            public double[] readFrom(DataInput in) throws IOException {<a name="line.298"></a>
<FONT color="green">299</FONT>                                    final double[] arr = new double[arrayLength];<a name="line.299"></a>
<FONT color="green">300</FONT>                                    for (int i = 0; i &lt; arr.length; i++) {<a name="line.300"></a>
<FONT color="green">301</FONT>                                            arr[i] = in.readDouble();<a name="line.301"></a>
<FONT color="green">302</FONT>                                    }<a name="line.302"></a>
<FONT color="green">303</FONT>                                    return arr;<a name="line.303"></a>
<FONT color="green">304</FONT>                            }<a name="line.304"></a>
<FONT color="green">305</FONT>                            public int getByteWidth() {return 8*arrayLength;}<a name="line.305"></a>
<FONT color="green">306</FONT>                    };<a name="line.306"></a>
<FONT color="green">307</FONT>            }<a name="line.307"></a>
<FONT color="green">308</FONT>            public static FixedWidthMarshaller&lt;boolean[]&gt; getForFixedBooleanArray(final int arrayLength) {<a name="line.308"></a>
<FONT color="green">309</FONT>                    return new FixedWidthMarshaller&lt;boolean[]&gt;() {<a name="line.309"></a>
<FONT color="green">310</FONT>                            public void writeTo(boolean[] entity, DataOutput out) throws IOException {<a name="line.310"></a>
<FONT color="green">311</FONT>                                    if (entity.length != arrayLength) {<a name="line.311"></a>
<FONT color="green">312</FONT>                                            throw new IOException("invalid array length " + <a name="line.312"></a>
<FONT color="green">313</FONT>                                                            entity.length + ", expected " + arrayLength); <a name="line.313"></a>
<FONT color="green">314</FONT>                                    }<a name="line.314"></a>
<FONT color="green">315</FONT>                                    for (int i = 0; i &lt; arrayLength; i++) {<a name="line.315"></a>
<FONT color="green">316</FONT>                                            out.writeBoolean(entity[i]);<a name="line.316"></a>
<FONT color="green">317</FONT>                                    }<a name="line.317"></a>
<FONT color="green">318</FONT>                            }<a name="line.318"></a>
<FONT color="green">319</FONT>                            public boolean[] readFrom(DataInput in) throws IOException {<a name="line.319"></a>
<FONT color="green">320</FONT>                                    final boolean[] arr = new boolean[arrayLength];<a name="line.320"></a>
<FONT color="green">321</FONT>                                    for (int i = 0; i &lt; arr.length; i++) {<a name="line.321"></a>
<FONT color="green">322</FONT>                                            arr[i] = in.readBoolean();<a name="line.322"></a>
<FONT color="green">323</FONT>                                    }<a name="line.323"></a>
<FONT color="green">324</FONT>                                    return arr;<a name="line.324"></a>
<FONT color="green">325</FONT>                            }<a name="line.325"></a>
<FONT color="green">326</FONT>                            public int getByteWidth() {return arrayLength;}<a name="line.326"></a>
<FONT color="green">327</FONT>                    };<a name="line.327"></a>
<FONT color="green">328</FONT>            }<a name="line.328"></a>
<FONT color="green">329</FONT>            public static FixedWidthMarshaller&lt;char[]&gt; getForFixedCharArray(final int arrayLength) {<a name="line.329"></a>
<FONT color="green">330</FONT>                    return new FixedWidthMarshaller&lt;char[]&gt;() {<a name="line.330"></a>
<FONT color="green">331</FONT>                            public void writeTo(char[] entity, DataOutput out) throws IOException {<a name="line.331"></a>
<FONT color="green">332</FONT>                                    if (entity.length != arrayLength) {<a name="line.332"></a>
<FONT color="green">333</FONT>                                            throw new IOException("invalid array length " + <a name="line.333"></a>
<FONT color="green">334</FONT>                                                            entity.length + ", expected " + arrayLength); <a name="line.334"></a>
<FONT color="green">335</FONT>                                    }<a name="line.335"></a>
<FONT color="green">336</FONT>                                    for (int i = 0; i &lt; arrayLength; i++) {<a name="line.336"></a>
<FONT color="green">337</FONT>                                            out.writeChar(entity[i]);<a name="line.337"></a>
<FONT color="green">338</FONT>                                    }<a name="line.338"></a>
<FONT color="green">339</FONT>                            }<a name="line.339"></a>
<FONT color="green">340</FONT>                            public char[] readFrom(DataInput in) throws IOException {<a name="line.340"></a>
<FONT color="green">341</FONT>                                    final char[] arr = new char[arrayLength];<a name="line.341"></a>
<FONT color="green">342</FONT>                                    for (int i = 0; i &lt; arr.length; i++) {<a name="line.342"></a>
<FONT color="green">343</FONT>                                            arr[i] = in.readChar();<a name="line.343"></a>
<FONT color="green">344</FONT>                                    }<a name="line.344"></a>
<FONT color="green">345</FONT>                                    return arr;<a name="line.345"></a>
<FONT color="green">346</FONT>                            }<a name="line.346"></a>
<FONT color="green">347</FONT>                            public int getByteWidth() {return 2*arrayLength;}<a name="line.347"></a>
<FONT color="green">348</FONT>                    };<a name="line.348"></a>
<FONT color="green">349</FONT>            }<a name="line.349"></a>
<FONT color="green">350</FONT>            <a name="line.350"></a>
<FONT color="green">351</FONT>            // no instances<a name="line.351"></a>
<FONT color="green">352</FONT>            private PrimitiveArrayMarshallers() {}<a name="line.352"></a>
<FONT color="green">353</FONT>    }<a name="line.353"></a>




























































</PRE>
</BODY>
</HTML>
